<?php

namespace Service;

date_default_timezone_set('America/Sao_Paulo');

class Movopsol {

    private $entityManager;
    private $parametros;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, \Service\Parametros $parametros) {
        $this->entityManager = $entityManager;
        $this->parametros = $parametros;
    }

    public function criaMovopsol($rows) {
       
        $movopsol = new \Factory\Movopsol();
        $this->entityManager->getConnection()->beginTransaction();
    
        foreach ($rows as $row) {

            $params = array(
                'cdfilsoli' => $row['CDFILSOLMOV'],
                'cdfillan' => $row['CDFILLANMOV'],
                'nrsolicmp' => $row['NRSOLIMOV'],
                'cdproduto' => $row['CDPRODUTO'],
                'dtprogentr' => $this->toDate($row['DTPROGENTR']),
            );

            $produtoExiste = $this->entityManager->getRepository('Model\Itemsoli')->findBy($params);

            if(!empty($produtoExiste)) {
                $parametrosFilial = $this->parametros->retornaParametros($row['CDFILSOLMOV'], $row['NRORG']);
                if ((empty($parametrosFilial[0]['IDUTAPROVSOL'])) || ($parametrosFilial[0]['IDUTAPROVSOL'] == 'N') || 
                    ($parametrosFilial[0]['IDUTAPROVSOL'] == 'S' && $parametrosFilial[0]['ALTERAR_PRODUTO_APROVADO'] == 'S') ||
                    ($parametrosFilial[0]['IDUTAPROVSOL'] == 'S' && $parametrosFilial[0]['ALTERAR_PRODUTO_APROVADO'] == 'N' && $produtoExiste[0]->getIdsoliaprov() == "N")
                ) {
                    $log = $movopsol->criaMovopsol($row);
                    $this->entityManager->persist($log);
                }
            } else {
                $log = $movopsol->criaMovopsol($row);
                $this->entityManager->persist($log);
            }
            

        }

        $this->entityManager->flush();
        $this->entityManager->getConnection()->commit();
       
    }

    private function toDate($stringDate) {
        $explodeDate = explode("/", $stringDate);
        $date = $explodeDate[2].'-'.$explodeDate[1].'-'.$explodeDate[0];
        return $date;
    }
}